#include "scene.h"
#include "V3.h"
#include "m33.h"
#include "tm.h"

Scene *scene;

using namespace std;

#include <iostream>
#include <fstream>
#include <strstream>

Scene::Scene() {


	int u0 = 20;
	int v0 = 40;
	int h = 400;
	int w = 600;
	fb = new FrameBuffer(u0, v0, w, h);
	fb->position(u0, v0);
	fb->label("SW Framebuffer");
	fb->show();
	fb->redraw();
	float hfov = 60.0f;
	ppc = new PPC(hfov, fb->w, fb->h);

	gui = new GUI();
	gui->show();
	gui->uiw->position(u0, v0 + fb->h + v0);

	tmsN = 1;
	tms = new TM[tmsN];


}


void Scene::DBG() {
	cerr << endl;

#if 0
	{
		unsigned int col = 0xFF000001;
		V3 colorv;
		colorv.SetFromColor(col);
		cerr << colorv << endl;
		return;
	}
#endif
	{
		tms[0].LoadBin("geometry/teapot1K.bin");
//`		tms[0].LoadBin("geometry/teapot57K.bin");
		tms[0].onFlag = 1;
		V3 centroid = tms[0].Centroid();

		tms[0].SetAllColors(V3(1.0f, 0.0f, 0.0f));

		tms[0].Translate(V3(0.0f, 0.0f, -150.0f) - centroid);
		centroid = V3(0.0f, 0.0f, -150.0f);

		Render();
		return;


//		tms[0].SetRectangle(V3(1.0f, 0.0f, 0.0f));

		V3 lv(0.0f, 0.0f, 1.0f);
		for (int fi = 0; fi < 3600; fi++) {

			tms[0].SetAllColors(V3(1.0f, 0.0f, 0.0f));
			float ka = 0.0f;
			tms[0].Light(ka, lv);

			Render();
			fb->redraw();
			Fl::check();

			lv = lv.RotateThisPointdAboutAxis(V3(0.0f, 0.0f, 0.0f), V3(0.0f, 1.0f, 0.0f), 1.0f);

		}

		Render();
		return;

		V3 newC = centroid + V3(100.0f, 150.0f, 0.0f);
		V3 newVD = (centroid - newC).UnitVector();
		V3 newUpG(0.0f, 1.0f, 0.0f);
//		ppc->SetPose(newC, newVD, newUpG);
		Render();
		fb->redraw();
		PPC ppc2(90.0f, fb->w, fb->h);
		ppc2.C = centroid;
		ppc2.RenderWF(fb, 10.0f, ppc);
		fb->redraw();


		for (int fi = 0; fi < 3600; fi++) {
			Render();
			ppc2.RenderWF(fb, 10.0f, ppc);
			fb->redraw();
			Fl::check();
			ppc2.Translate(V3(.01f, 0.0f, 0.0f));
//			tms[0].Rotate(centroid, V3(0.0f, 1.0f, 0.0f), 0.1f);
//			tms[0].ScaleInPlace(0.999f);
//			ppc->Translate(V3(1.0f, 0.0f, 0.0f));
		}
		return;
	}

	{
		TM tm;
		float rw = 40.0f;
		float rh = 20.0f;
		tm.SetRectangle(rw, rh);
		tm.Translate(V3(0.0f, 0.0f, -40.0f));
		for (int fi = 0; fi < 1000; fi++) {
			fb->Set(0xFFFFFFFF);
			tm.RenderWF(fb, ppc);
			tm.Translate(V3(0.0f, 0.0f, -.1f));
			fb->redraw();
			Fl::check();
		}
		return;
	}

	{
		V3 P(0.0f, 0.0f, -100.0f);
		V3 Q;
		if (!ppc->Project(P, Q))
			return;
		fb->Set(0xFFDDDDDD);
		fb->RasterizeCircle(Q, 3.0f, 0xFF0000FF);
		fb->redraw();
		return;
	}

	{
		int fN = 1000;
		V3 p0(20.0f, 30.3f, 0.0f);
		V3 p1(220.0f, 130.3f, 0.0f);
		for (int fi = 0; fi < fN; fi++) {
			fb->Set(0xFFDDDDDD);
			V3 c0(0.0f, 0.0f, 0.0f);
			V3 c1(0.0f, 0.0f, 0.0f);
			fb->Rasterize2DSegment(p0, p1, c0, c1);
			fb->redraw();
			Fl::check();
			p0 = p0 + V3(0.0f, +1.0f, 0.0f);
			p1 = p1 + V3(0.0f, -1.0f, 0.0f);
		}
		return;
	}
	{
		V3 center(100.3f, 200.9f, 0.0f);
		float radius = 34.1f;
		fb->Set(0xFFFFFFFF);
		fb->RasterizeCircle(center, radius, 0xFF000000);
		fb->redraw();
		return;
	}


	{
		int u0 = 30;
		int v0 = 50;
		int l = 100;
		int h = 200;
		int fN = 600;
		for (int fi = 0; fi < fN; fi++) {
			fb->Set(0xFFFFFFFF);
			unsigned int col = 0xFF00FF00;
			fb->RasterizeRectangle(u0, v0, l, h, col);
			fb->redraw();
			Fl::check();
			u0++;
		}
		return;
	}
	{
		M33 m;
		m[0] = V3(1.0f, 0.0f, 0.0f);
		m[1] = V3(0.0f, 1.0f, 0.0f);
		m[2] = V3(1.0f, 0.0f, 1.0f);
		cerr << m << endl;
		cerr << m.GetColumn(0);
		return;
		V3 v(10.0f, 9.0f, 3.0f);
		cerr << m*v << endl;
		return;
		cerr << "row 0: " << m[1] << endl;
		return;
	}
	{
		V3 v0(1.0f, 2.0f, 3.0f);
		cerr << endl << "v0: " << v0;
		return;
	}

	{
		V3 v0(1.0f, 2.0f, 3.0f);
		cerr << endl << v0[0] << " " << v0[1] << endl;
		v0[1] = 100.0f;
		return;
		V3 v1(2.0f, 2.0f, 2.0f);
		// v0[0]
		V3 v2 = v0 + v1;
		cerr << v2.xyz[0] << endl;
		return;
	}

	{
		cerr << "INFO: pressed DBG" << endl;
		fb->Set(0xFF0000FF);
		fb->redraw();
	}
}

void Scene::NewButton() {
	cerr << "INFO: pressed New button on GUI" << endl;
}






void Scene::Render() {

	if (!fb)
		return;

	fb->Set(0xFFFFFFFF);
	for (int tmi = 0; tmi < tmsN; tmi++) {
//		tms[tmi].RenderWF(fb, ppc);
		tms[tmi].RenderFilledMode(fb, ppc);
	}
	fb->redraw();

}